diff -u -r dillo-0.8.4.orig/dpi/downloads.c dillo-0.8.4/dpi/downloads.c
--- dillo-0.8.4.orig/dpi/downloads.c	2004-12-28 21:50:06.000000000 +0100
+++ dillo-0.8.4/dpi/downloads.c	2005-02-25 14:24:30.351805000 +0100
@@ -39,12 +39,12 @@
 //#define DEBUG_MSG
 
 /* Convinience for the error message stream */
-#define eprintf(fmt...) fprintf(stderr, fmt)
+#define eprintf(...) fprintf(stderr, __VA_ARGS__)
 
 #ifdef DEBUG_MSG
-#  define ceprintf(fmt...) eprintf(fmt)
+#  define ceprintf(...) eprintf(__VA_ARGS__)
 #else
-#  define ceprintf(fmt...)
+#  define ceprintf(...)
 #endif
 
 pid_t origpid, fpid;
diff -u -r dillo-0.8.4.orig/dpi/dpiutil.h dillo-0.8.4/dpi/dpiutil.h
--- dillo-0.8.4.orig/dpi/dpiutil.h	2004-12-28 21:11:57.000000000 +0100
+++ dillo-0.8.4/dpi/dpiutil.h	2005-02-25 15:58:21.867230000 +0100
@@ -33,9 +33,9 @@
 void sock_handler_close(SockHandler *sh);
 void sock_handler_free(SockHandler *sh);
 
-#define sock_handler_printf(sh, flush, fmt...)           \
+#define sock_handler_printf(sh, flush, ...)              \
    G_STMT_START {                                        \
-      gchar *str = g_strdup_printf(fmt);                 \
+      gchar *str = g_strdup_printf(__VA_ARGS__);	 \
       sock_handler_write(sh, str, strlen(str), flush);   \
       g_free(str);                                       \
    } G_STMT_END
diff -u -r dillo-0.8.4.orig/dpi/file.c dillo-0.8.4/dpi/file.c
--- dillo-0.8.4.orig/dpi/file.c	2004-12-28 21:08:13.000000000 +0100
+++ dillo-0.8.4/dpi/file.c	2005-02-25 14:24:58.670149000 +0100
@@ -38,8 +38,8 @@
 #define MAXNAMESIZE 30
 #define HIDE_DOTFILES TRUE
 
-#define _MSG(fmt...)
-#define MSG(fmt...)  g_print("[file dpi]: " fmt)
+#define _MSG(...)
+#define MSG(...)  g_print("[file dpi]: " __VA_ARGS__)
 
 enum {
    FILE_OK,
diff -u -r dillo-0.8.4.orig/src/IO/http.c dillo-0.8.4/src/IO/http.c
--- dillo-0.8.4.orig/src/IO/http.c	2004-12-21 17:46:08.000000000 +0100
+++ dillo-0.8.4/src/IO/http.c	2005-02-25 14:27:04.598332000 +0100
@@ -39,10 +39,10 @@
 #include "../misc.h"
 
 /* Used to send a message to the bw's status bar */
-#define BW_MSG(web, root, fmt...)                                     \
+#define BW_MSG(web, root, ...)                                        \
 G_STMT_START {                                                        \
    if (a_Web_valid((web)) && (!(root) || (web)->flags & WEB_RootUrl)) \
-      a_Interface_msg((web)->bw, fmt);                                \
+      a_Interface_msg((web)->bw, __VA_ARGS__);                        \
 } G_STMT_END
 
 #define DEBUG_LEVEL 5
diff -u -r dillo-0.8.4.orig/src/debug.h dillo-0.8.4/src/debug.h
--- dillo-0.8.4.orig/src/debug.h	2004-05-22 00:13:07.000000000 +0200
+++ dillo-0.8.4/src/debug.h	2005-02-25 14:21:25.969072000 +0100
@@ -16,13 +16,13 @@
 
 
 # ifdef DEBUG_LEVEL
-#    define DEBUG_MSG(level, fmt...)                  \
+#    define DEBUG_MSG(level, ...)		      \
         G_STMT_START {                                \
            if (DEBUG_LEVEL && (level) >= DEBUG_LEVEL) \
-              g_print(fmt);                           \
+	     g_print(__VA_ARGS__);		      \
         } G_STMT_END
 # else
-#    define DEBUG_MSG(level, fmt...)
+#    define DEBUG_MSG(level, ...)
 # endif /* DEBUG_LEVEL */
 
 
@@ -43,10 +43,10 @@
       fflush (stdout); \
    } G_STMT_END
 
-#define DBG_MSGF(obj, aspect, prio, fmt, args...) \
+#define DBG_MSGF(obj, aspect, prio, fmt, ...) \
    G_STMT_START { \
       printf ("[rtfl]%s:%d:%d:msg:%p:%s:%d:" fmt "\n", \
-              __FILE__, __LINE__, getpid(), obj, aspect, prio, args); \
+              __FILE__, __LINE__, getpid(), obj, aspect, prio, __VA_ARGS__); \
       fflush (stdout); \
    } G_STMT_END
 
@@ -130,7 +130,7 @@
 #else /* DBG_RTFL */
 
 #define DBG_MSG(obj, aspect, prio, msg)
-#define DBG_MSGF(obj, aspect, prio, fmt, arg...)
+#define DBG_MSGF(obj, aspect, prio, fmt, ...)
 #define DBG_MSG_START(obj)
 #define DBG_MSG_END(obj)
 #define DBG_OBJ_CREATE(obj, klass)
diff -u -r dillo-0.8.4.orig/src/dw_widget.h dillo-0.8.4/src/dw_widget.h
--- dillo-0.8.4.orig/src/dw_widget.h	2004-08-20 02:09:53.000000000 +0200
+++ dillo-0.8.4/src/dw_widget.h	2005-02-25 14:42:01.335099000 +0100
@@ -377,7 +377,8 @@
 
 /* for convenience */
 #define     a_Dw_iterator_unhighlight(it, l) ((it) ? \
-                                    (it)->highlight(it, -1, -1, l) : FALSE)
+					      (it)->highlight(it, -1, -1, l) \
+					      : (void)FALSE)
 void        a_Dw_iterator_scroll_to  (DwIterator *it1,
                                       DwIterator *it2,
                                       gint start,
diff -u -r dillo-0.8.4.orig/src/msg.h dillo-0.8.4/src/msg.h
--- dillo-0.8.4.orig/src/msg.h	2004-05-22 00:13:12.000000000 +0200
+++ dillo-0.8.4/src/msg.h	2005-02-25 14:22:51.887281000 +0100
@@ -6,22 +6,22 @@
 /*
  * You can disable any MSG* macro by adding the '_' prefix.
  */
-#define _MSG(fmt...)
-#define _MSG_HTML(fmt...)
-#define _MSG_HTTP(fmt...)
+#define _MSG(...)
+#define _MSG_HTML(...)
+#define _MSG_HTTP(...)
 
 
-#define MSG(fmt...)                    \
+#define MSG(...)                    \
    G_STMT_START {                      \
       if (prefs.show_msg)              \
-         g_print(fmt);                 \
+         g_print(__VA_ARGS__);                 \
    } G_STMT_END
 
-#define MSG_HTML(fmt...)               \
+#define MSG_HTML(...)               \
    G_STMT_START {                      \
-         Html_msg(html, fmt);          \
+         Html_msg(html, __VA_ARGS__);          \
    } G_STMT_END
 
-#define MSG_HTTP(fmt...)  g_print("HTTP warning: " fmt)
+#define MSG_HTTP(...)  g_print("HTTP warning: " __VA_ARGS__)
 
 #endif /* __MSG_H__ */